; TortoiseCVS.nsi
;
; Installer script for TortoiseCVS
;

; TODO:
; Check new text at end of installation
; Launch help after first reboot?
; Directory not removed on uninstallation
; Remove ins files in uninst mid installation (also rename to .installing again?)

Name "TortoiseCVS"
OutFile "TortoiseCVS.exe"
SetOverwrite on

; The default installation directory
InstallDir $PROGRAMFILES\TortoiseCVS
InstallDirRegKey HKEY_LOCAL_MACHINE "Software\TortoiseCVS" "Directory" 

; The text to prompt the user to enter a directory
DirText "Choose where to install. You can update TortoiseCVS by installing a new version in the same place as the old one."

; For FinishedText, apply patch to NSIS (unless it is in the official build by now)
; While you're at it, you'll also need the patch to fix file copying on reboot.
FinishedText "Please reboot to complete the installation.  When$\r$\ndone choose TortoiseCVS | Help from the Start$\r$\nmenu to get going.$\r$\n$\r$\nGrooviness! You'll need to reboot though. Sigh."

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; The stuff to install

Section "ThisNameIsIgnoredSoWhyBother?"
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  ; Put files there
  File "TortoiseConflict.ico"
  File "TortoiseChanged.ico"
  File "TortoiseNotInCVS.ico"
  File "TortoiseInCVS.ico"
  File "help.html"
  File "legal.html"
  File "faq.html"
  File "guide.html"
  File "style.css"
  File "GPL.html"
  File "charlie.jpeg"
  File "philosophical-gnu-sm.jpg"
  File "ChangeLog.txt"
  File "TortoiseMenus.config"
  File "ssh-keygen.exe"
  File "ssh.readme.txt"

  ; These might be in use, in particular TortoiseShell.dll will
  ; be held open by Explorer.  So we install as another name...
  File /oname=cvs2ntlib.dll.ins cvs2ntlib.dll
  File /oname=cvs2ntslib.dll.ins cvs2ntslib.dll
  File /oname=TortoiseShell.dll.ins TortoiseShell.dll
  File /oname=TortoiseAct.exe.ins TortoiseAct.exe
  File /oname=ssh.exe.ins ssh.exe
  File /oname=zlib.dll.ins zlib.dll
  File /oname=gmp.dll.ins gmp.dll
  ; ... and move into place on reboot
  Rename /REBOOTOK "$INSTDIR\cvs2ntlib.dll.ins" "$INSTDIR\cvs2ntlib.dll"
  Rename /REBOOTOK "$INSTDIR\cvs2ntslib.dll.ins" "$INSTDIR\cvs2ntslib.dll"
  Rename /REBOOTOK "$INSTDIR\TortoiseShell.dll.ins" "$INSTDIR\TortoiseShell.dll"
  Rename /REBOOTOK "$INSTDIR\TortoiseAct.exe.ins" "$INSTDIR\TortoiseAct.exe"
  Rename /REBOOTOK "$INSTDIR\ssh.exe.ins" "$INSTDIR\ssh.exe"
  Rename /REBOOTOK "$INSTDIR\zlib.dll.ins" "$INSTDIR\zlib.dll"
  Rename /REBOOTOK "$INSTDIR\gmp.dll.ins" "$INSTDIR\gmp.dll"

  ; Register ourself:

  ; As four COM controls, as we need one for each icon overlay (silly interface!)
  WriteRegStr HKEY_CLASSES_ROOT CLSID\{5d1cb710-1c4b-11d4-bed5-005004b1f42f} "" TortoiseCVS
  WriteRegStr HKEY_CLASSES_ROOT CLSID\{5d1cb710-1c4b-11d4-bed5-005004b1f42f}\InProcServer32 "" $INSTDIR\TortoiseShell.dll
  WriteRegStr HKEY_CLASSES_ROOT CLSID\{5d1cb710-1c4b-11d4-bed5-005004b1f42f}\InProcServer32 "ThreadingModel" Apartment
  WriteRegStr HKEY_CLASSES_ROOT CLSID\{5d1cb711-1c4b-11d4-bed5-005004b1f42f} "" TortoiseCVS
  WriteRegStr HKEY_CLASSES_ROOT CLSID\{5d1cb711-1c4b-11d4-bed5-005004b1f42f}\InProcServer32 "" $INSTDIR\TortoiseShell.dll
  WriteRegStr HKEY_CLASSES_ROOT CLSID\{5d1cb711-1c4b-11d4-bed5-005004b1f42f}\InProcServer32 "ThreadingModel" Apartment
  WriteRegStr HKEY_CLASSES_ROOT CLSID\{5d1cb712-1c4b-11d4-bed5-005004b1f42f} "" TortoiseCVS
  WriteRegStr HKEY_CLASSES_ROOT CLSID\{5d1cb712-1c4b-11d4-bed5-005004b1f42f}\InProcServer32 "" $INSTDIR\TortoiseShell.dll
  WriteRegStr HKEY_CLASSES_ROOT CLSID\{5d1cb712-1c4b-11d4-bed5-005004b1f42f}\InProcServer32 "ThreadingModel" Apartment
  WriteRegStr HKEY_CLASSES_ROOT CLSID\{5d1cb713-1c4b-11d4-bed5-005004b1f42f} "" TortoiseCVS
  WriteRegStr HKEY_CLASSES_ROOT CLSID\{5d1cb713-1c4b-11d4-bed5-005004b1f42f}\InProcServer32 "" $INSTDIR\TortoiseShell.dll
  WriteRegStr HKEY_CLASSES_ROOT CLSID\{5d1cb713-1c4b-11d4-bed5-005004b1f42f}\InProcServer32 "ThreadingModel" Apartment

  ; As the actual icon overlay handlers for Explorer
  WriteRegStr HKEY_LOCAL_MACHINE Software\Microsoft\Windows\CurrentVersion\Explorer\ShellIconOverlayIdentifiers\TortoiseCVS0 "" {5d1cb710-1c4b-11d4-bed5-005004b1f42f}
  WriteRegStr HKEY_LOCAL_MACHINE Software\Microsoft\Windows\CurrentVersion\Explorer\ShellIconOverlayIdentifiers\TortoiseCVS1 "" {5d1cb711-1c4b-11d4-bed5-005004b1f42f}
  WriteRegStr HKEY_LOCAL_MACHINE Software\Microsoft\Windows\CurrentVersion\Explorer\ShellIconOverlayIdentifiers\TortoiseCVS2 "" {5d1cb712-1c4b-11d4-bed5-005004b1f42f}
  WriteRegStr HKEY_LOCAL_MACHINE Software\Microsoft\Windows\CurrentVersion\Explorer\ShellIconOverlayIdentifiers\TortoiseCVS3 "" {5d1cb713-1c4b-11d4-bed5-005004b1f42f}

  ; As approved by the administrator
  WriteRegStr HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved" {5d1cb710-1c4b-11d4-bed5-005004b1f42f} "Tortoise CVS"
  WriteRegStr HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved" {5d1cb711-1c4b-11d4-bed5-005004b1f42f} "Tortoise CVS"
  WriteRegStr HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved" {5d1cb712-1c4b-11d4-bed5-005004b1f42f} "Tortoise CVS"
  WriteRegStr HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved" {5d1cb713-1c4b-11d4-bed5-005004b1f42f} "Tortoise CVS"

  ; As numerous contex menu handlers for Explorer
  WriteRegStr HKEY_CLASSES_ROOT Directory\shellex\ContextMenuHandlers\TortoiseCVS "" {5d1cb710-1c4b-11d4-bed5-005004b1f42f}
  WriteRegStr HKEY_CLASSES_ROOT Directory\Background\shellex\ContextMenuHandlers\TortoiseCVS "" {5d1cb710-1c4b-11d4-bed5-005004b1f42f}
  WriteRegStr HKEY_CLASSES_ROOT Drive\shellex\ContextMenuHandlers\TortoiseCVS "" {5d1cb710-1c4b-11d4-bed5-005004b1f42f}
  WriteRegStr HKEY_CLASSES_ROOT Folder\shellex\ContextMenuHandlers\TortoiseCVS "" {5d1cb710-1c4b-11d4-bed5-005004b1f42f}
  WriteRegStr HKEY_CLASSES_ROOT *\shellex\ContextMenuHandlers\TortoiseCVS "" {5d1cb710-1c4b-11d4-bed5-005004b1f42f}

  ; As a property page handler
  WriteRegStr HKEY_CLASSES_ROOT *\shellex\PropertySheetHandlers\TortoiseCVS "" {5d1cb710-1c4b-11d4-bed5-005004b1f42f}

  ; Start menu entries
  CreateDirectory "$SMPROGRAMS\TortoiseCVS"
  CreateShortCut "$SMPROGRAMS\TortoiseCVS\Help.lnk" "$INSTDIR\help.html" 
;"" "$WINDIR\Explorer.exe" 7
  CreateShortCut "$SMPROGRAMS\TortoiseCVS\Preferences.lnk" "$INSTDIR\TortoiseAct.exe" CVSPrefs

  ; Uninstallation
  WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\TortoiseCVS" "UninstallString" "$INSTDIR\UninstallTortoiseCVS.exe"
  WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\TortoiseCVS" "DisplayName" "TortoiseCVS"

  WriteRegStr HKEY_LOCAL_MACHINE "Software\TortoiseCVS" "Directory" "$INSTDIR"

SectionEnd ; end the section


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This stuff to uninstall

UninstallExeName UninstallTortoiseCVS.exe
Section "Uninstall"
  ; Remove all our files (reboot required to finish)
  Delete "$INSTDIR\TortoiseConflict.ico"
  Delete "$INSTDIR\TortoiseChanged.ico"
  Delete "$INSTDIR\TortoiseNotInCVS.ico"
  Delete "$INSTDIR\TortoiseInCVS.ico"
  Delete "$INSTDIR\help.html"
  Delete "$INSTDIR\legal.html"
  Delete "$INSTDIR\faq.html"
  Delete "$INSTDIR\guide.html"
  Delete "$INSTDIR\style.css"
  Delete "$INSTDIR\GPL.html"
  Delete "$INSTDIR\charlie.jpeg"
  Delete "$INSTDIR\philosophical-gnu-sm.jpg"
  Delete "$INSTDIR\ChangeLog.txt"
  Delete "$INSTDIR\TortoiseMenus.config"
  Delete "$INSTDIR\ssh-keygen.exe"
  Delete "$INSTDIR\ssh.readme.txt"
  Delete /REBOOTOK "$INSTDIR\cvs2ntlib.dll"
  Delete /REBOOTOK "$INSTDIR\cvs2ntslib.dll"
  Delete /REBOOTOK "$INSTDIR\TortoiseShell.dll"
  Delete /REBOOTOK "$INSTDIR\TortoiseAct.exe"
  Delete /REBOOTOK "$INSTDIR\ssh.exe"
  Delete /REBOOTOK "$INSTDIR\zlib.dll"
  Delete /REBOOTOK "$INSTDIR\gmp.dll"

  ; Unregister ourself:
  ; As COM controls
  DeleteRegKey HKEY_CLASSES_ROOT CLSID\{5d1cb710-1c4b-11d4-bed5-005004b1f42f}
  DeleteRegKey HKEY_CLASSES_ROOT CLSID\{5d1cb711-1c4b-11d4-bed5-005004b1f42f}
  DeleteRegKey HKEY_CLASSES_ROOT CLSID\{5d1cb712-1c4b-11d4-bed5-005004b1f42f}
  DeleteRegKey HKEY_CLASSES_ROOT CLSID\{5d1cb713-1c4b-11d4-bed5-005004b1f42f}
  ; As icon handlers for Explorer
  DeleteRegKey HKEY_LOCAL_MACHINE Software\Microsoft\Windows\CurrentVersion\Explorer\ShellIconOverlayIdentifiers\TortoiseCVS0
  DeleteRegKey HKEY_LOCAL_MACHINE Software\Microsoft\Windows\CurrentVersion\Explorer\ShellIconOverlayIdentifiers\TortoiseCVS1
  DeleteRegKey HKEY_LOCAL_MACHINE Software\Microsoft\Windows\CurrentVersion\Explorer\ShellIconOverlayIdentifiers\TortoiseCVS2
  DeleteRegKey HKEY_LOCAL_MACHINE Software\Microsoft\Windows\CurrentVersion\Explorer\ShellIconOverlayIdentifiers\TortoiseCVS3
  ; As approved by admin
  DeleteRegValue HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved" {5d1cb710-1c4b-11d4-bed5-005004b1f42f}
  DeleteRegValue HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved" {5d1cb711-1c4b-11d4-bed5-005004b1f42f}
  DeleteRegValue HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved" {5d1cb712-1c4b-11d4-bed5-005004b1f42f}
  DeleteRegValue HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved" {5d1cb713-1c4b-11d4-bed5-005004b1f42f}
  ; As context menu handlers for Explorer
  DeleteRegKey HKEY_CLASSES_ROOT Directory\shellex\ContextMenuHandlers\TortoiseCVS
  DeleteRegKey HKEY_CLASSES_ROOT Directory\Background\shellex\ContextMenuHandlers\TortoiseCVS
  DeleteRegKey HKEY_CLASSES_ROOT Drive\shellex\ContextMenuHandlers\TortoiseCVS
  DeleteRegKey HKEY_CLASSES_ROOT Folder\shellex\ContextMenuHandlers\TortoiseCVS
  DeleteRegKey HKEY_CLASSES_ROOT *\shellex\ContextMenuHandlers\TortoiseCVS
  ; As property page handler
  DeleteRegKey HKEY_CLASSES_ROOT *\shellex\PropertySheetHandlers\TortoiseCVS

  ; Remove saved settings keys
  DeleteRegKey HKEY_CURRENT_USER Software\TortoiseCVS
  DeleteRegKey HKEY_LOCAL_MACHINE Software\TortoiseCVS

  ; Remove start menu entries
  RMDir /r "$SMPROGRAMS\TortoiseCVS"

  ; Delete self
  DeleteRegKey HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\TortoiseCVS"
  Delete "$INSTDIR\UninstallTortoiseCVS.exe"
  RMDir $INSTDIR
SectionEnd


; eof
