// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - May 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef PRESERVE_CHDIR_H
#define PRESERVE_CHDIR_H

// Some of the CVS functions do a chdir, which when in the explorer
// process space causes problems - you can't delete some directories,
// and it breaks multiple select in the file open dialog.  Whenever
// a shell extension calls CVS glue, it should instantiate this class.

#include <stdlib.h> // _MAX_PATH

class PreserveChdir
{
public:
	PreserveChdir();
	~PreserveChdir();

private:
	char originalCurrentDirectory[_MAX_PATH + 1];
};

#endif
