// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - May 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <windows.h>
#include <wx/wx.h>
#include <iostream>
#include "CVSStatus.h"
#include "CVSAction.h"
#include "../TortoiseAct/TortoiseDialogs.h"

#ifdef _MSC_VER
#pragma warning(disable:4786 4503)
#endif

void StatusTest(std::string file)
{
	CVSStatus::FileStatus status = CVSStatus::GetFileStatus(file);
	if (status == CVSStatus::STATUS_NOWHERENEAR_CVS)
		std::cout << "STATUS_NOWHERENEAR_CVS";
	if (status == CVSStatus::STATUS_INCVS)
		std::cout << "STATUS_INCVS";
	if (status == CVSStatus::STATUS_CHANGED)
		std::cout << "STATUS_CHANGED";
	if (status == CVSStatus::STATUS_CONFLICT)
		std::cout << "STATUS_CONFLICT";
	if (status == CVSStatus::STATUS_NOTINCVS)
		std::cout << "STATUS_NOTINCVS";
	if (status == CVSStatus::STATUS_OUTERDIRECTORY)
		std::cout << "STATUS_OUTERDIRECTORY";

}

class MyApp : public wxApp
{
public:
   bool OnInit();
};

DECLARE_APP(MyApp)

IMPLEMENT_APP(MyApp)

bool MyApp::OnInit()
{
	return true;
}

void main()
{
	std::cout << "CVS glue test" << std::endl;

/*	
	std::string protocol, userName, password, serverMachine, repositoryDirectory, module;
	if (DoCheckoutDialog(protocol, userName, password, serverMachine, repositoryDirectory, module))
	{
		std::cout << "OK" << std::endl;
		std::cout << protocol << " " << userName << " " << password << " " << serverMachine << " " << repositoryDirectory << " " << module;
	}
	else 
	{
		std::cout << "Cancel" << std::endl;
		return;
	}
*/

/*
	bool text;
	// std::string file = "D:\\cvswork\\DockingStation\\Code\\website\\website.sln";
	// std::string file = "D:\\cvswork\\TortoiseCVS\\PathUtils.h";
	std::string file = "D:\\cvswork\\tester\\foo";
	bool result = DoTextBinaryDialog(text, file);
	return;
*/

/*	
	CVSAction glue;
	glue.SetCloseIfOK(false);
	{
		MakeArgs args;
		args.add("update");
		args.add(".");
		glue.Command("D:\\cvswork\\foo", args);
	}
*/

	CVSStatus::GetFileStatus("D:\\cvswork\\test\\tester\\Copy (2) of moose.txt");
	  
    std::vector<std::string> modified, added, removed;
	CVSStatus::RecursiveScan("d:\\cvswork\\test\\tester", modified, added, removed);
	{
		std::cout << "MODIFIED: ";
		for (int i = 0; i < modified.size(); ++i)
			std::cout << modified[i] << " ";
		std::cout << std::endl;
	}
	{
		std::cout << "ADDED: ";
		for (int i = 0; i < added.size(); ++i)
			std::cout << added[i] << " ";
		std::cout << std::endl;
	}
	{
		std::cout << "REMOVED: ";
		for (int i = 0; i < removed.size(); ++i)
			std::cout << removed[i] << " ";
		std::cout << std::endl;
	}

	DoMessageDialog("Hello, everyone cool fun blah!");
}
