// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - September 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef MENU_DESCRIPTION_H
#define MENU_DESCRIPTION_H

#include <vector>
#include <string>
#include <windows.h>

class MenuDescription
{
public:
	MenuDescription(const std::string& verb, const std::string& menuText, int flags, const std::string& helpText);
	MenuDescription();

	int GetFlags();
	std::string GetVerb();
	std::string GetMenuText();
	std::string GetHelpText();

	// TODO: I _so_ don't want this header to have a dependence on windows.h
	// How to refactor it so it doesn't need to?  (For HWND)
	void Perform(const std::vector<std::string>& files, HWND hwnd);

private:
	int myFlags;
	std::string myVerb;
	std::string myMenuText;
	std::string myHelpText;
};


#endif
