// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - May 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "ChooseFile.h"
#include "WxwHelpers.h"
#include <string>
#include <wx/filedlg.h>

std::string DoOpenFileDialog(const std::string& titleMessage, const std::string& startBrowsingFrom, const std::string& patterns)
{
	wxFileDialog* dlg = new wxFileDialog(NULL, titleMessage.c_str(),
		"", startBrowsingFrom.c_str(), patterns.c_str(), wxOPEN | wxHIDE_READONLY);

	int ret = dlg->ShowModal();
	std::string retString = (ret == wxID_OK) ? std::string(dlg->GetPath()) : std::string("");

	DestroyDialog(dlg);
	return retString;
}

std::string DoSaveFileDialog(const std::string& titleMessage, const std::string& startBrowsingFrom, const std::string& patterns)
{
	wxFileDialog* dlg = new wxFileDialog(NULL, titleMessage.c_str(),
		"", startBrowsingFrom.c_str(), patterns.c_str(), wxSAVE | wxHIDE_READONLY | wxOVERWRITE_PROMPT);

	int ret = dlg->ShowModal();
	std::string retString = (ret == wxID_OK) ? std::string(dlg->GetPath()) : std::string("");

	DestroyDialog(dlg);
	return retString;
}


