// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Ben Campbell
// <ben.campbell@creaturelabs.com> - September 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef COMMIT_DIALOG_H
#define COMMIT_DIALOG_H

#ifdef _MSC_VER
#pragma warning(disable:4786 4503)
#endif

#include <string>
#include <vector>
#include <wx/wx.h>
#include <wx/checklst.h>

class CommitDialog : wxDialog
{
public:
	friend bool DoCommitDialog(const std::vector<std::string>& modified,
		const std::vector<std::string>& added, const std::vector<std::string>& removed,
		std::string& comment, std::vector<std::string>& userSelection);

private:
	enum { modeTag, modeBranch };

	enum {
		CD_DIFF_MODIFIED = 10001,
		CD_WEB_LOG_MODIFIED,
		CD_WEB_LOG_REMOVED,
	};

	CommitDialog(std::vector<std::string> modified, std::vector<std::string> added, std::vector<std::string> removed, const std::string& defaultComment);
	static void ShortenPaths(std::vector<std::string>& files, std::string& stub);
	void ContextMenuModified(const wxMouseEvent& event);
	void ContextMenuRemoved(const wxMouseEvent& event);
	void ContextMenuAdded(const wxMouseEvent& event);
	void WebLogRemoved();
	void EmptyCommentWarning();

	virtual long MSWWindowProc(WXUINT nMsg, WXWPARAM wParam, WXLPARAM lParam);

	wxCheckListBox* myModified;
	wxCheckListBox* myAdded;
	wxCheckListBox* myRemoved;
	wxTextCtrl* myComment;
	wxButton* myOK;
	wxStaticText* myCommentWarning;

	std::string myModifiedStub, myAddedStub, myRemovedStub;
};

#endif

