// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Ben Campbell
// <ben.campbell@creaturelabs.com> - September 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "MergeDlg.h"
#include "WxwHelpers.h"

//static
bool DoMergeDialog( std::string& fromtag )
{
	MergeDlg* dlg = new MergeDlg();
	bool ret = (dlg->ShowModal() == wxID_OK);

	if (ret)
	{
		fromtag = dlg->myFromEntry->GetValue();
	}

	DestroyDialog(dlg);
	return ret;
}


MergeDlg::MergeDlg()
	: wxDialog(NULL, -1, wxString( "TortoiseCVS - Merge" ),
	wxDefaultPosition, wxSize(400,300), wxDEFAULT_DIALOG_STYLE)
{
	SetIcon(wxIcon("TORTOISE", wxBITMAP_TYPE_ICO_RESOURCE));

	// Top part with tag entry field
	wxBoxSizer *sizerFromEntry= new wxBoxSizer(wxHORIZONTAL);
	wxStaticText *label = new wxStaticText(this, -1, "Branch to merge from:" );
    myFromEntry = new wxTextCtrl(this, -1, "");
	myFromEntry->SetToolTip( "Name of revision/tag/branch to merge into your working dir." );
    sizerFromEntry->Add(label, 0, wxALIGN_CENTER_VERTICAL | wxGROW | wxALL, 5);
    sizerFromEntry->Add(myFromEntry, 1, wxGROW | wxALL, 5);
	myFromEntry->SetFocus();

	// information text
	std::string inf;
	wxStaticText *infoText = new wxStaticText( this, -1,
		"The specified revision/tag/branch will be merged into "
		"your current working sources.\n"
		"The repository is not altered until a commit is performed." );

	// OK/Cancel button
	wxBoxSizer *sizerConfirm = new wxBoxSizer(wxHORIZONTAL);
    wxButton* ok = new wxButton(this, wxID_OK, "OK");
	ok->SetDefault();
    wxButton* cancel = new wxButton(this, wxID_CANCEL, "Cancel");
	sizerConfirm->Add(ok, 0, wxGROW | wxALL, 5);
    sizerConfirm->Add(cancel, 0, wxGROW | wxALL, 5);

	// Main box with everything in it
	wxBoxSizer *sizerTop = new wxBoxSizer(wxVERTICAL);
	sizerTop->Add(sizerFromEntry, 0, wxGROW | wxALL, 3);
	sizerTop->Add(infoText, 0, wxGROW | wxALL, 10);
	sizerTop->Add(sizerConfirm, 0, wxALIGN_CENTER | wxALL, 0);

	// Overall dialog layout settings
    SetAutoLayout(TRUE);
    SetSizer(sizerTop);
    sizerTop->SetSizeHints(this);
    sizerTop->Fit(this);
}
