// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - May 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef MODULE_BASICS_PAGE_H
#define MODULE_BASICS_PAGE_H

#include <wx/wx.h>
#include <wx/notebook.h>
#include <string>
#include <list>

// This class implements the layout for the first page
// of the checkout dialog.

class ModuleBasicsPage : public wxPanel
{
public:
	ModuleBasicsPage(wxNotebook* notebook);
	// For make new module (module is already choosen by folder name)
	void SetFixedModule(const std::string& module);

	std::string GetProtocol() { return myProtocol; }
	std::string GetUsername() { return myUsername; };
	std::string GetServer() { return myServer; };
	std::string GetDirectory() { return myDirectory; };
	std::string GetModule() { return myModule; };

	void OKClicked();

private:
	wxChoice* myProtocolMenu;
	wxComboBox* myUsernameCombo;
	wxComboBox* myServerCombo;
	wxComboBox* myDirectoryCombo;
	wxComboBox* myModuleCombo;
	wxStaticText* myCVSROOTLabel;

	std::string myProtocol;
	std::string myUsername;
	std::string myServer;
	std::string myDirectory;
	std::string myModule;

	void Refresh();
	void UpdateSensitivity();
	bool NeedUserName();
	bool NeedServer();
};

#endif //MODULE_BASICS_PAGE_H


