// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - October 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef PREFERENCES_DIALOG_H
#define PREFERENCES_DIALOG_H

#ifdef _MSC_VER
#pragma warning(disable:4786 4503)
#endif

#include <string>
#include <map>

#include "../TortoiseAct/TortoisePreferences.h"
#include <wx/wx.h>
class Preference;

class PreferencesDialog : wxDialog
{
public:
	// Allow the user to edit all the preferences passed in.
	// Changes their values if they click OK.
	friend void DoPreferencesDialog(TortoisePreferences& prefs);

private:
	PreferencesDialog(TortoisePreferences& prefs);

	std::vector<wxControl*> myWidgets;
	std::vector<wxControl*> myWidgetsExtra;
	std::map<std::string, wxPanel*> myPages;
	wxNotebook *myNotebook;

	void AddPreference(const Preference& pref, wxControl* &widget, wxControl* &widgetExtra, int ix);
	void ExtractPreference(Preference& pref, wxControl* widget);

	void RefreshGhosting();
	void DirectoryBrowse(wxEvent& event);
	
	TortoisePreferences& myPrefs;
 };

#endif

