// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - September 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef WXW_HELPERS
#define WXW_HELPERS

#ifdef _MSC_VER
// turn off stupid debug-too-long warning
#pragma warning(disable:4786 4503)
#endif

#undef GetCharWidth
#include <wx/wx.h>
#include <string>
#include <vector>

// General helper
template<class T>
std::vector<wxString> ConvertToWxStringArray(const T& t)
{
	std::vector<wxString> result;
	for (typename T::const_iterator it = t.begin(); it != t.end(); ++it)
		result.push_back(it->c_str());
	return result;
}

// wxComboList
wxComboBox* MakeComboList(wxWindow* parent, const std::string& registryName, const std::string& extraDefault = "");
void WriteComboList(wxComboBox* widg, const std::string& registryName);

// wxChoice
void ReadOptionMenu(wxChoice* widg, const std::string& registryName);
void WriteOptionMenu(wxChoice* widg, const std::string& registryName);

// Return a parent window to use
wxWindow* GetAppropriateParent();

// Wrapper for wxWindows destruction, as dialog-centric apps
// aren't very stable in wxWindows yet.
void DestroyDialog(wxDialog* dlg);

#endif
