// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - October 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef TORTOISE_PREFERENCES_H
#define TORTOISE_PREFERENCES_H

#ifdef _MSC_VER
// turn off stupid debug-too-long warning
#pragma warning(disable:4786 4503)
#endif

// A simple vector of preferences, which constructs itself with one
// for each preference in TortoiseCVS.

#include "../Utils/Preference.h"
#include <vector>

class TortoisePreferences
{
    public:
	TortoisePreferences();
	~TortoisePreferences();

	unsigned int GetCount();
	Preference& Lookup(int index);

    private:
	std::vector<Preference> myPrefs;
};

#endif
