// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - September 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "TortoiseTip.h"
#include <windows.h>

// TODO: Remove this, when we use the new style commit dialog all the time
std::string TortoiseTip(const std::string& scanText)
{
	if (scanText.find("Log message unchanged or not specified", 0) != std::string::npos)
	{
		return
			
		"Tortoise Tip:  This error happens if you didn't enter a message at the top\n"
		"of the Notepad window when you performed a commit.  Please try again and\n"
		"enter some text, describing roughly what you changed.\n\n"
		"There is also a bug in CVS under Windows which can cause this to happen.\n"
		"If you save the file too quickly, CVS doesn't notice that it has changed.\n"
		"Try again, and wait a few seconds before saving the file!";
	}

	if ((scanText.find("\nC ", 0) != std::string::npos)
		|| scanText.substr(0, 2) == "C ")
	{
		return

		"Tortoise Tip:  It looks like one or more of your files has a conflict.  This\n"
		"means that someone else has altered that file since you last updated.  Look\n"
		"above for the files marked \"C \", and manually edit them to resolve the conflict.";
	}

	if (scanText.find("No CVSROOT specified!", 0) != std::string::npos)
	{
		return

		"Tortoise Tip:  This error can be caused by a folder called \"CVS\" which was\n"
		"made by you rather than by CVS.  If so, please rename the folder to something\n"
		"else such as \"cvswork\".";
	}

	return "";
}

	