// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - May 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef PATH_UTILS_H
#define PATH_UTILS_H

// g++ cygwin compatibility
#include <stdlib.h>
#ifndef _MAX_PATH
	#define _MAX_PATH MAX_PATH
#endif

#include <string>
#include <vector>

bool FileExists(const char* filename);
bool IsDirectory(const char* filename);
int FileSize(const char* filename);

std::string GetDirectoryAbove(std::string filename);
std::string GetDirectoryPart(std::string filename);

void RemoveTrailingDelimiter(std::string& pathorfile);
void EnsureTrailingDelimiter(std::string& pathorfile);

bool CVSFolderHere(std::string path);

std::string ExtractLastPart(std::string pathorfile);

std::string GetFirstPart(std::string pathorfile);
std::string StripFirstPart(std::string pathorfile);

std::string GetTemporaryPath();
std::string UniqueTemporaryFile();

std::string MyDocumentsFolder();

void GetRecursiveContents(std::string path, std::vector<std::string>& files, const std::string& wildcard);
bool CopyFolderRecursively(std::string source, std::string dest);

bool IsRootPath(const std::string& PathName);

#endif
