// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - May 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef SHELL_UTILS_H
#define SHELL_UTILS_H

#include <windows.h>
#include <shlobj.h>
#include <string>

// Opens an Explorer context menu.
bool DoExplorerMenu(HWND hwnd, LPCTSTR pszPath, POINT P);
// You are contractually obliged to call this function from hwnd's
// WndProc during a call to DoExplorerMenu.  It passes on owner
// draw commands. If it returns true, then it has handled the message.
bool DoExplorerMenuWndProc(const MSG &msg);

// Explorer pidl data structure walking functions.
// These are probably compatible with Borland builder ones
// of the same name (judging by usenet posting snippets).
// _Who_ invented this stuff in an API?  Madness.
LPITEMIDLIST GetNextItem(LPITEMIDLIST pidl);
int GetItemCount(LPITEMIDLIST pidl);
UINT GetSize(LPITEMIDLIST pidl);
LPITEMIDLIST DuplicateItem(LPMALLOC pMalloc, LPITEMIDLIST pidl);

// Launch a command, optionally wait for termination
bool LaunchCommand(const std::string& command, bool waitForEnd);

#endif
