// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - May 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "TortoiseException.h"
#include "../TortoiseAct/TortoiseDialogs.h"
#include <windows.h>
#include <stdio.h>

void TortoiseFatalError(const std::string& errorMessage)
{
	DoMessageDialog(errorMessage);
	exit(1);
}

void DisplaySystemError()
{
	int err = GetLastError();

	char errBuf[4096];

	char buffer[4096];
	buffer[0] = 0;
	if (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, 0, err, 0, buffer, 4095, NULL) == 0)
		sprintf(errBuf, "(error %d)", err);
	else
		sprintf(errBuf, "\n%s", buffer);
	
	DoMessageDialog(errBuf);	
}
