// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - May 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef TORTOISE_REGISTRY_H
#define TORTOISE_REGISTRY_H


#ifdef _MSC_VER
// turn off stupid debug-too-long warning
#pragma warning(disable:4786 4503)
#endif

#include <string>
#include <list>

class TortoiseRegistry
{
public:
	// If you don't specify a default, ReadString() returns "" if entry not found.
	static std::string ReadString(const std::string& name, const std::string& defaultValue = "");
	static void WriteString(const std::string& name, const std::string& value);

	static int ReadInteger(const std::string& name, int defaultValue);
	static void WriteInteger(const std::string& name, int value);

	static bool ReadBoolean(const std::string& name, bool defaultValue);
	static void WriteBoolean(const std::string& name, bool value);

	static void ReadList( std::string const& basekey,
		std::list< std::string >& strings );
	static void WriteList( std::string const& basekey,
		std::list< std::string > const& strings );

	// WinCVS compatibility
	static std::string ReadWinCVSString(const std::string& name, const std::string& defaultValue = "");

private:
};

#endif
