// TortoiseCVS - a Windows shell extension for easy version control

// Copyright (C) 2000 - Francis Irving
// <francis@flourish.org> - May 2000

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "UnicodeStrings.h"
#include <windows.h>
#include "PathUtils.h" // for _MAX_PATH

std::string WideToMultibyte(wide_string wide)
{
	char narrow[_MAX_PATH * 3];
	BOOL defaultCharUsed;
	int ret = WideCharToMultiByte(CP_ACP, 0, wide.c_str(), wide.size(), narrow, _MAX_PATH*3 - 1, ".", &defaultCharUsed);
	narrow[ret] = 0;
	return std::string(narrow);
}

wide_string MultibyteToWide(std::string multibyte)
{
	wchar_t wide[_MAX_PATH * 3];
	int ret = MultiByteToWideChar(CP_ACP, 0, multibyte.c_str(), multibyte.size(), wide, _MAX_PATH*3 - 1);
	wide[ret] = 0;
	return wide_string(wide);
}


