/*
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 1, or (at your option)
** any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef  CVSLOGPARSER_H
#define CVSLOGPARSER_H

#include "CvsLog.h"

template <class PARSED>
class Parser
{
public:
	virtual void Reset() = 0;
	virtual void StartParse() = 0;
	virtual void EndParse() = 0;
	virtual bool IsParsing() = 0;
	virtual PARSED & operator*() = 0;
	virtual PARSED * operator->() = 0;
};

class CvsLogParser
{
public:
	virtual void Reset() = 0;
	virtual Parser<CRcsFile> & RcsFile() = 0;
	virtual Parser<CRevFile> & RevFile() = 0;
	virtual Parser<CRevNumber> & Branch() = 0;
	virtual Parser<CRevNumber> & Symbolic() = 0;
	virtual Parser<CLogStr> & Access() = 0;
	virtual Parser<CRevNumber> & Lock() = 0;
};

#endif
